'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *  * 参考
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://github.com/chemzqm/iscroll
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _componentTween = require('component-tween');

var _componentTween2 = _interopRequireDefault(_componentTween);

var _componentRaf = require('component-raf');

var _componentRaf2 = _interopRequireDefault(_componentRaf);

var _throttleit = require('throttleit');

var _throttleit2 = _interopRequireDefault(_throttleit);

var _debounce = require('debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _mouseWheelEvent = require('mouse-wheel-event');

var _mouseWheelEvent2 = _interopRequireDefault(_mouseWheelEvent);

var _style = require('perfect-dom/lib/style');

var _ScrollBar = require('./ScrollBar');

var _ScrollBar2 = _interopRequireDefault(_ScrollBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// 函数
var max = Math.max,
    min = Math.min;


var now = Date.now || function () {
  return new Date().getTime();
};

// 计算回弹速度效果
function outBack(n) {
  var s = 1.20158;
  return --n * n * ((s + 1) * n + s) + 1;
}

/**
 * 初始化 Scroll 设置宽度和选项
 * options.scrollBar 设为 true 则显示scrollBar
 * @param {Object} options
 */

var Scroll = function () {
  function Scroll(options) {
    _classCallCheck(this, Scroll);

    var _options = _extends({}, options);
    Object.keys(_options).forEach(function (item) {
      if (_options[item] === undefined) {
        delete _options[item];
      }
    });

    _options = _extends({}, Scroll.defaultOptions, _options);
    this.options = _options;

    // 初始化y 坐标
    this.y = 0;
    this.maxAmplitude = _options.maxAmplitude;
    var _options2 = _options,
        wrapper = _options2.wrapper;

    var scroller = wrapper.children[0];
    // 包裹区域元素
    this.wrapper = wrapper;
    // 内层元素
    this.scroller = scroller;
    this.scrollerMargin = parseInt((0, _style.getStyles)(this.scroller, 'marginBottom'), 10) + parseInt((0, _style.getStyles)(this.scroller, 'marginTop'), 10);

    this.handleEvent = this.handleEvent.bind(this);
    this._initEvent();

    this.refresh(true);

    if (options.scrollBar !== false) {
      this.scrollBar = new _ScrollBar2.default(wrapper, options.barClassName);
    }
    this.onScrollEnd = (0, _debounce2.default)(this.onScrollEnd, _options.debounceTime);
    this.transformScrollBar = (0, _throttleit2.default)(this.transformScrollBar, _options.throttleTime);
  }

  // 事件句柄

  //默认属性


  _createClass(Scroll, [{
    key: 'handleEvent',
    value: function handleEvent(e) {
      /*eslint-disable indent*/
      switch (e.type) {
        case 'touchstart':
          this.ontouchstart(e);
          break;
        case 'touchmove':
          this.ontouchmove(e);
          break;
        case 'touchcancel':
        case 'touchend':
        case 'touchleave':
          this.ontouchend(e);
          break;
        default:
          break;
      }
    }

    /**
     * 删除所有监听，当页面卸载时
     */

  }, {
    key: 'unmount',
    value: function unmount() {
      this._initEvent(true);
      if (this.scrollBar) {
        this.scrollBar.unmount();
      }
      this._wheelUnbind();
    }

    /**
     * 初始化或卸载事件
     * @param detach 设为 true 表示卸载
     */

  }, {
    key: '_initEvent',
    value: function _initEvent(detach) {
      var action = detach ? 'removeEventListener' : 'addEventListener';

      this.wrapper[action]('touchstart', this.handleEvent);
      this.wrapper[action]('touchmove', this.handleEvent);
      this.wrapper[action]('touchleave', this.handleEvent, true);
      this.wrapper[action]('touchend', this.handleEvent, true);
      this.wrapper[action]('touchcancel', this.handleEvent, true);

      //添加鼠标滚动事件，在pc 端也可以操作
      this._wheelUnbind = (0, _mouseWheelEvent2.default)(this.wrapper, this.onwheel.bind(this), true);
    }

    /**
     * 重新计算高度
     * @param noScroll 如果还没有滚动时，直接返回，即初始化的时候
     */

  }, {
    key: 'refresh',
    value: function refresh(noScroll) {
      var sh = this.viewHeight = this.wrapper.getBoundingClientRect().height;
      var ch = this.height = this.scroller.getBoundingClientRect().height + this.scrollerMargin;
      //计算最小高度
      this.minY = min(0, sh - ch);
      if (noScroll === true) {
        return;
      }
      //滑到最下面
      if (this.y < this.minY) {
        this.scrollTo(this.minY, 300);
        // 滑到最上面
      } else if (this.y > 0) {
        this.scrollTo(0, 300);
      }
    }

    /**
     * touchstart 事件句柄
     *
     * @param  {Event}  e
     */

  }, {
    key: 'ontouchstart',
    value: function ontouchstart(e) {
      this.speed = null;
      this.down = null;
      if (this.tween) {
        this.tween.stop();
      }
      this.refresh(true);
      var start = this.y;
      if (e.target === this.wrapper) {
        start = min(start, 0);
        start = max(start, this.minY);
        // 定位到开始位置
        if (start !== this.y) {
          return this.scrollTo(start, 200);
        }
        return;
      }

      var touch = this.getTouch(e);
      var sx = touch.clientX;
      var sy = touch.clientY;
      var at = now();
      var thresholdOffset = this.options.thresholdOffset;


      this.onstart = function (x, y) {
        // 判断是否超过移动临界值
        if (Math.abs(sy - y) <= thresholdOffset) {
          return;
        }
        //更新完重置为 null
        this.onstart = null;
        var dx = Math.abs(x - sx);
        var dy = Math.abs(y - sy);
        // 左右移动时，或略
        if (dx > dy) {
          return;
        }
        this.clientY = touch.clientY;
        this.dy = 0;
        this.ts = now();
        this.down = {
          x: sx,
          y: sy,
          start: start,
          at: at
        };
        if (this.scrollBar) {
          this.resizeScrollBar();
        }
        return true;
      };
    }

    /**
     * touchmove 事件句柄
     *
     * @param  {Event}  e
     */

  }, {
    key: 'ontouchmove',
    value: function ontouchmove(e) {
      e.preventDefault();

      if (!this.down && !this.onstart) {
        return;
      }
      var touch = this.getTouch(e);
      var x = touch.clientX;
      var y = touch.clientY;
      if (this.onstart) {
        var started = this.onstart(x, y);
        if (started !== true) {
          return;
        }
      }
      var down = this.down;

      var dy = y - down.y;

      // 当页面到达最上面时，禁止滑动
      if (this.options.disableBounceTop && this.y >= 0 && dy > 0) {
        return;
      }

      // 当页面到达最下面时，禁止滑动
      if (this.options.disableBounceBottom && this.y <= this.viewHeight - this.height && dy < 0) {
        return;
      }

      this.dy = dy;

      // 计算速度，按每 100 milisecond
      this.calcuteSpeed(touch.clientY, down.at);
      var start = this.down.start;

      var dest = start + dy;
      dest = min(dest, this.maxAmplitude);
      dest = max(dest, this.minY - this.maxAmplitude);
      this.translate(dest);
    }

    /**
     * touchend 事件句柄
     *
     * @param  {Event}  e
     */

  }, {
    key: 'ontouchend',
    value: function ontouchend(e) {
      if (!this.down) return;
      var at = this.down.at;

      this.down = null;
      var touch = this.getTouch(e);
      this.calcuteSpeed(touch.clientY, at);
      var m = this.momentum();
      this.scrollTo(m.dest, m.duration, m.ease);
    }
  }, {
    key: 'onwheel',
    value: function onwheel(dx, dy) {
      if (Math.abs(dx) > Math.abs(dy)) {
        return;
      }
      if (this.scrollBar) {
        this.resizeScrollBar();
      }
      var y = this.y - dy;
      if (y > 0) y = 0;
      if (y < this.minY) y = this.minY;
      if (y === this.y) {
        return;
      }
      this.scrollTo(y, 20, 'linear');
    }

    /**
     * 计算加速度
     * @param {Number} y
     */

  }, {
    key: 'calcuteSpeed',
    value: function calcuteSpeed(y, start) {
      var ts = now();
      var dt = ts - this.ts;
      if (ts - start < 100) {
        this.distance = y - this.clientY;
        this.speed = Math.abs(this.distance / dt);
      } else if (dt > 100) {
        this.distance = y - this.clientY;
        this.speed = Math.abs(this.distance / dt);
        this.ts = ts;
        this.clientY = y;
      }
    }

    /**
     * 计算移动的动画效果
     * @return {Object}
     */

  }, {
    key: 'momentum',
    value: function momentum() {
      var deceleration = this.options.deceleration;
      var speed = this.speed;
      var _options3 = this.options,
          scrollSpeed = _options3.scrollSpeed,
          durationSpeed = _options3.durationSpeed;

      speed = min(speed, scrollSpeed);
      var y = this.y;

      var rate = (scrollSpeed - Math.PI) / 2;
      var destination = y + rate * speed * speed / (2 * deceleration) * (this.distance < 0 ? -1 : 1);
      var duration = speed / deceleration / durationSpeed;
      var ease = void 0;
      var minY = this.minY;

      if (y > 0 || y < minY) {
        duration = 600;
        ease = 'out-quart';
        destination = y > 0 ? 0 : minY;
      } else if (destination > 0 || destination < minY) {
        ease = outBack;
        destination = destination > 0 ? 0 : minY;
        duration = 2 * Math.abs(destination - y + 40) / speed;
      }

      return {
        dest: destination,
        duration: duration,
        ease: ease
      };
    }

    /**
     * Scroll to potions y with optional duration and ease function
     * 使用动画效果滑动到指定的位置
     * @param {Number} y
     * @param {Number} duration
     * @param {String} easing
     */

  }, {
    key: 'scrollTo',
    value: function scrollTo(y, duration, easing) {
      var _this = this;

      if (this.tween) this.tween.stop();
      var transition = duration > 0 && y !== this.y;
      if (!transition) {
        this.direction = 0;
        this.translate(y);
        return this.onScrollEnd();
      }

      this.direction = y > this.y ? -1 : 1;

      easing = easing || this.options.easing;
      var tween = this.tween = (0, _componentTween2.default)({
        y: this.y
      }).ease(easing).to({
        y: y
      }).duration(duration);

      tween.update(function (o) {
        _this.translate(o.y);
      });

      var _animate = function animate() {
        (0, _componentRaf2.default)(_animate);
        tween.update();
      };

      var promise = new Promise(function (resolve) {
        tween.on('end', function () {
          resolve();
          _this.animating = false;
          _animate = function _animate() {};
          if (!tween.stopped) {
            // no emit scrollend if tween stopped
            _this.onScrollEnd();
          }
        });
      });

      _animate();
      this.animating = true;
      return promise;
    }

    /**
     * 返回 touch 事件
     */

  }, {
    key: 'getTouch',
    value: function getTouch(e) {
      var touch = e;
      if (e.changedTouches && e.changedTouches.length > 0) {
        touch = e.changedTouches[0];
      }
      return touch;
    }

    /**
     * 移动
     */

  }, {
    key: 'translate',
    value: function translate(y) {
      var style = this.scroller.style;

      if (isNaN(y)) return;
      y = Math.floor(y);
      // reach the end
      if (this.y !== y) {
        this.y = y;
        if (this.scrollBar) {
          this.transformScrollBar();
        }
      }
      style.webkitTransform = 'translate3d(0, ' + y + 'px, 0)';
      style.transform = 'translate3d(0, ' + y + 'px, 0)';
    }

    /**
     * 显示 scrollBar 并重新计算 scrollBar 大小
     */

  }, {
    key: 'resizeScrollBar',
    value: function resizeScrollBar() {
      var _options4 = this.options,
          disableBounceTop = _options4.disableBounceTop,
          disableBounceBottom = _options4.disableBounceBottom;

      if (disableBounceTop && disableBounceBottom && this.viewHeight > this.height) {
        return;
      }
      var vh = this.viewHeight;
      var h = vh * vh / this.height;
      this.scrollBar.resize(h);
    }

    /**
     * 隐藏 scrollBar
     */

  }, {
    key: 'hideScrollBar',
    value: function hideScrollBar() {
      if (this.scrollBar) {
        this.scrollBar.hide();
      }
    }

    /**
     * 活动结束时触发该事件
     *
     */

  }, {
    key: 'onScrollEnd',
    value: function onScrollEnd() {
      if (this.animating) return;
      this.hideScrollBar();
    }

    /**
     * 移动 scrollBar
     */

  }, {
    key: 'transformScrollBar',
    value: function transformScrollBar() {
      var vh = this.viewHeight;
      var h = this.height;
      var y = Math.round(-(vh - vh * vh / h) * this.y / (h - vh));
      this.scrollBar.translateY(y);
    }

    /**
     * 返回当前位移值
     * @returns {number|*}
     */

  }, {
    key: 'getScrollTop',
    value: function getScrollTop() {
      return this.y;
    }
  }, {
    key: 'getScrollHeight',
    value: function getScrollHeight() {
      return this.height;
    }
  }, {
    key: 'getScrollViewHeight',
    value: function getScrollViewHeight() {
      return this.viewHeight;
    }
  }]);

  return Scroll;
}();

Scroll.defaultOptions = {
  scrollBar: true,
  barClassName: '', // bar Class
  maxAmplitude: 80, // 设置上下滑动最大弹性振幅度，单位为像素，默认为 80 像素
  debounceTime: 50, // 防抖时间
  throttleTime: 100, // 滑动条移动频率，值越大，移动的越缓慢
  deceleration: 0.001, // 设置弹性滑动持续时间，即滑动停止时，弹性持续的时间
  thresholdOffset: 2, // 设置上下移动临界值，移动超过该值，则向上或向下滑动
  scrollSpeed: 4, // 设置滚动加速度，值越大，滚动越快
  durationSpeed: 3, // 滑动持续时间系数，系数越大，持续的时间短，
  easing: 'linear', // 设置加速方式，默认为匀速，详情查看 https://github.com/component/ease
  disableBounceTop: false, // 是否禁用顶部弹跳，当页面到达最上面时，触发 touch 事件阻止向下滑动
  disableBounceBottom: false // 是否禁用底部弹跳，当页面到达最下面时，触发 touch 事件阻止向上滑动
};
exports.default = Scroll;