'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Scroll = require('./Scroll');

var _Scroll2 = _interopRequireDefault(_Scroll);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * React Scroll 组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ReactScroll = function (_Component) {
  _inherits(ReactScroll, _Component);

  function ReactScroll() {
    _classCallCheck(this, ReactScroll);

    return _possibleConstructorReturn(this, (ReactScroll.__proto__ || Object.getPrototypeOf(ReactScroll)).apply(this, arguments));
  }

  _createClass(ReactScroll, [{
    key: 'componentDidMount',

    //可能需要传入的参数
    value: function componentDidMount() {
      //初始化 Scroll 实例
      var _props = this.props,
          barClassName = _props.barClassName,
          scrollBar = _props.scrollBar,
          maxAmplitude = _props.maxAmplitude,
          debounceTime = _props.debounceTime,
          throttleTime = _props.throttleTime,
          deceleration = _props.deceleration,
          scrollSpeed = _props.scrollSpeed,
          thresholdOffset = _props.thresholdOffset,
          durationSpeed = _props.durationSpeed,
          easing = _props.easing,
          disableBounceTop = _props.disableBounceTop,
          disableBounceBottom = _props.disableBounceBottom;
      var wrapper = this.refs.wrapper;

      this.scroll = new _Scroll2.default({
        wrapper: wrapper,
        scrollBar: scrollBar,
        barClassName: barClassName,
        maxAmplitude: maxAmplitude,
        debounceTime: debounceTime,
        throttleTime: throttleTime,
        deceleration: deceleration,
        scrollSpeed: scrollSpeed,
        thresholdOffset: thresholdOffset,
        durationSpeed: durationSpeed,
        easing: easing,
        disableBounceTop: disableBounceTop,
        disableBounceBottom: disableBounceBottom
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.scroll.unmount();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          className = _props2.className;


      return _react2.default.createElement(
        'div',
        { className: 'rc-scroll-wrapper' + (className ? ' ' + className : ''), ref: 'wrapper' },
        _react2.default.createElement(
          'div',
          { className: 'rc-scroll' },
          children
        )
      );
    }
  }]);

  return ReactScroll;
}(_react.Component);

ReactScroll.propTypes = {
  className: _propTypes2.default.string, // 自定义样式
  children: _propTypes2.default.node, // 待渲染的内容
  scrollBar: _propTypes2.default.bool, // 是否显示滚动条
  barClassName: _propTypes2.default.string, // 自定义 bar 样式
  maxAmplitude: _propTypes2.default.number, // 设置上下滑动最大弹性振幅度，单位为像素，默认为 80 像素
  debounceTime: _propTypes2.default.number, // 设置防抖时间
  throttleTime: _propTypes2.default.number, // 设置滑动条移动频率，值越大，移动的越缓慢
  deceleration: _propTypes2.default.number, // 设置弹性滑动持续时间，即滑动停止时，弹性持续的时间，值越大，持续时间越短
  scrollSpeed: _propTypes2.default.number, // 设置滚动加速度，值越大，滚动越快
  thresholdOffset: _propTypes2.default.number, // 设置上下移动临界值，移动超过该值，则向上或向下滑动
  durationSpeed: _propTypes2.default.number, // 滑动持续时间系数，系数越大，持续的时间短
  easing: _propTypes2.default.string, // 设置加速方式，默认为匀速，详情查看 https://github.com/component/ease
  disableBounceTop: _propTypes2.default.bool, // 是否禁用顶部弹跳，当页面到达最上面时，触发 touch 事件阻止向下滑动
  disableBounceBottom: _propTypes2.default.bool // 是否禁用底部弹跳，当页面到达最下面时，触发 touch 事件阻止向上滑动
};
ReactScroll.defaultProps = {};
exports.default = ReactScroll;