'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * ScrollBar 类
 *
 * @param {Element} scrollPanel
 * @contructor
 */
var ScrollBar = function () {
  function ScrollBar(scrollPanel, className) {
    _classCallCheck(this, ScrollBar);

    var scrollBar = document.createElement('div');
    scrollBar.className = className || 'rc-scrollbar';
    scrollPanel.appendChild(scrollBar);
    this.scrollPanel = scrollPanel;
    this.scrollBar = scrollBar;
  }

  /**
   * 重新计算 scrollBar 大小
   * @param {Number} height
   */


  _createClass(ScrollBar, [{
    key: 'resize',
    value: function resize(height) {
      var style = this.scrollBar.style;
      //滚动条最小高度为 20

      if (height < 20) {
        height = 20;
      }
      style.height = height + 'px';
      style.backgroundColor = 'rgba(0,0,0,0.4)';
    }

    /**
     * 隐藏 scrollBar
     */

  }, {
    key: 'hide',
    value: function hide() {
      this.scrollBar.style.backgroundColor = 'transparent';
    }

    /**
     * 移动 scrollBar
     * @param {Number} y
     */

  }, {
    key: 'translateY',
    value: function translateY(y) {
      var style = this.scrollBar.style;

      style.webkitTransform = 'translate3d(0, ' + y + 'px, 0)';
      style.transform = 'translate3d(0, ' + y + 'px, 0)';
    }
  }, {
    key: 'unmount',
    value: function unmount() {
      this.scrollPanel.removeChild(this.scrollBar);
    }
  }]);

  return ScrollBar;
}();

exports.default = ScrollBar;